'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.moduleloader = undefined;

var _jspm = require('jspm');

var _jspm2 = _interopRequireDefault(_jspm);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const moduleloader = (events, system, opts) => {
    if (typeof opts.packagePath !== 'string') {
        opts.packagePath = '.';
    }
    _jspm2.default.setPackagePath(opts.packagePath);
    const systemJS = new _jspm2.default.Loader();
    const systemInstantiate = SystemJS.instantiate;
    systemJS.instantiate = function (load) {
        const filename = load.address.replace('file://', '');
        if (system.files.includes(filename)) {
            load.source = system.callbacks.onFileSourceLoaded(load.source, filename);
        }
        return systemInstantiate.call(systemJS, load);
    };
    events.onLoad = () => {
        return Promise.all(system.files.map(file => systemJS.import(file))).catch(e => system.handleError(e));
    };
    events.onExit = () => {};
};

exports.moduleloader = moduleloader;